// Must be global as PhoneGAP could calls "app.launch()" before than Sencha
// Touch initialize the "app" object.
var launchCounter = 0;
var loadMask = null;



Ext.regApplication ({
	name: "app",
	useLoadMask: false,	// Manually managed.
	//phoneStartupScreen: 'images/piemonteagrilogo.jpg',
	//tabletStartupScreen: 'images/piemonteagrilogo.jpg',
	//icon: '...',
	//glossOnIcon: false,
	
	devicePosition: null,
	selectedMoviCentro: null,
	
	
	
	launch: function()
	{
		++ launchCounter;
		// On desktop systems PhoneGAP don't initializes, so process only
		// the first call; on mobile systems launch() will be called twice
		// (one time by Sencha Touch, one time by PhoneGAP).
		var launchCounterTarget = 1;
		if (launchCounter != launchCounterTarget)
		{
			return;
		}
		
		loadMask = new Ext.LoadMask (Ext.getBody());
		loadMask.show ();
		
		app.stores.bundle.load (Ext.createDelegate (this.bundleLoaded_, this));
    },
	
	
	
	selectMoviCentro: function (moviCentro)
	{
		this.selectedMoviCentro = moviCentro;
		// Load arrivals, then departures (done after receipt of arrivals).
		app.stores.arrivals.load (Ext.createDelegate (this.arrivalsLoaded_, this));
		app.stores.infos.load (Ext.createDelegate (this.infosLoaded_, this));
	},
	
	
	
	bundleLoaded_: function(records, operation, success)
	{
		if (success && records && records.length > 0)
		{
			// Retrieve user position.
			app.models.Geolocation.getCurrentPosition (
				Ext.createDelegate (this.receivedUserPosition_, this),
				Ext.createDelegate (this.unknownUserPosition_, this)
			);
		}
		else
		{
			console.log ("Problems loading localization bundle");
			alert ("Internal error: localization bundle not found");
		}
	},
	
	
	
	receivedUserPosition_: function (pos)
	{
		console.log ("receivedUserPosition_(): " + pos.get('latitude') + ', ' + pos.get('longitude'));
		this.devicePosition = pos;
		app.stores.moviCentroSet.load (Ext.createDelegate (this.moviCentroSetLoaded_, this));
	},
	
	
	
	unknownUserPosition_: function (error)
	{
		console.log (error);
		// Use a fake position (Acqui Terme).
		this.receivedUserPosition_ (
			Ext.ModelMgr.create (
				{
					latitude: 44.6755269,
					longitude: 8.4706692
				},
				"app.models.Geolocation"
			)
		);
	},
	
	
	
	moviCentroSetLoaded_: function(records, operation, success)
	{
		if (success && records && records.length > 0)
		{
			//this.views.viewport = new this.views.Viewport ();
			this.selectMoviCentro (records[0]);
		}
		else
		{
			console.log ("Problems loading MOVIcentro set");
			alert (app.stores.bundle.format ("networkError"));
		}
	},
	
	
	
	arrivalsLoaded_: function(records, operation, success)
	{
		if (success)
		{
			app.stores.departures.load (Ext.createDelegate (this.departuresLoaded_, this));
		}
		else
		{
			console.log ("Unable to download arrivals");
			alert (app.stores.bundle.format ("networkError"));
		}
	},
	
	
	
	departuresLoaded_: function(records, operation, success)
	{
		if (success)
		{
			// Everything has been sucessful loaded.
			this.showUI_ ();
		}
		else
		{
			console.log ("Unable to download departures");
			alert (app.stores.bundle.format ("networkError"));
		}
	},
	
	

	infosLoaded_: function(records, operation, success)
	{
		if (! success)
		{
			console.log ("Unable to download infos");
			alert (app.stores.bundle.format ("networkError"));
		}
		
		// Due to a bug in Sencha Touch, when empty data are returned the "update"
		// event on the view is not fired. Manualy invoke it.
		if (app.views.infoList)
		{
			app.views.infoList.dataLoaded_ (records, operation, success);
		}
	},

	
	
	showUI_: function ()
	{
		if (loadMask)
		{
			loadMask.destroy ();
			loadMask = null;
		}
		
		if (! this.views.viewport)
		{
			this.views.viewport = new this.views.Viewport ();
			this.useLoadMask = true;
			this.initLoadMask ();
		}
	}
});
