app.models.Geolocation = Ext.regModel (
	"app.models.Geolocation",
	{
		fields: [
			{ name: "latitude", type: "double" },
			{ name: "longitude", type: "double" }
		]
	}
);



/*
 * Retrieve the current geo-location of the device.
 */
app.models.Geolocation.getCurrentPosition = function (successCallback, failureCallback)
{
	// If unsupported
	if (! navigator.geolocation)
	{
		if (failureCallback && typeof(failureCallback) === "function")
		{
			failureCallback ("Geolocation unsupported");
		}
		return;
	}

	navigator.geolocation.getCurrentPosition (
		// On successful retrieval
		function (position)
		{
			var posModel = Ext.ModelMgr.create (
				{
					latitude: position.coords.latitude,
					longitude: position.coords.longitude
				},
				"app.models.Geolocation"
			);
			successCallback (posModel);
		},

		// On failure
		failureCallback,

		// Options
		{
			maximumAge: Infinity,
			timeout: 30000,
			enableHighAccuracy: true
		}
	)
}
