app.stores.bundle = new Ext.data.Store({
    model: "app.models.Bundle",
	
	proxy: {
		type: 'ajax',
		// 'url' dynamically added on load()
		reader: {
			type: 'json'
		}
	},
	
	
	
	// Override load() method.
	load: function (options)
	{
		// To smartly supports extensible languages we need server-side support.
		this.proxy.url = 'app/bundle.' + this.language + '.json';
		
		// Call super implementation.
		Ext.data.Store.prototype.load.call (this, options);
	},
	
	
	
	format: function ()
	{
		var args = Array.prototype.slice.call (arguments);
		var key = args.shift ();
		var b = this.findRecord ('key', key, 0, false, true, true);
		return b == null ? "" : b.format.apply (b, args);
	}
});



app.stores.bundle.language = (
	window.navigator.language.substr(0,2).toLowerCase() == "it" ?
	"it" :
	"en"
);
// Workaround for Android bug 4641 (http://code.google.com/p/android/issues/detail?id=4641),
// upstream WebKit bug 49099 (https://bugs.webkit.org/show_bug.cgi?id=49099)
if (Ext.is.Android)
{
	app.stores.bundle.language = "it";
}
console.log ("window.navigator.language = " + window.navigator.language);
console.log ("app.stores.bundle.language = " + app.stores.bundle.language);
