app.stores.moviCentroSet = new Ext.data.Store({
    model: "app.models.MoviCentro",
	
	proxy: {
		type: appConfig.webservice.getMOVIcentro.type || 'scripttag',
		url : appConfig.webservice.getMOVIcentro.url,
		reader: {
			type: 'json'
		}
		// extraParams dynamically added on load()
	},
	
	
	
	// Override load() method.
	load: function (options)
	{
		this.proxy.extraParams = {
			longitude: app.devicePosition.get ('longitude'),
			latitude: app.devicePosition.get ('latitude')
		};
		Ext.apply (this.proxy.extraParams, appConfig.webservice.getMOVIcentro.options);
		// Call super implementation.
		Ext.data.Store.prototype.load.call (this, options);
	}
});



app.stores.arrivals = new Ext.data.Store({
    model: "app.models.Journey",
	
	proxy: {
		type: appConfig.webservice.getArrivals.type || 'scripttag',
		url : appConfig.webservice.getArrivals.url,
		reader: {
			type: 'json'
		}
		// extraParams dynamically added on load()
	},
	
	
	
	// Override load() method.
	load: function (options)
	{
		this.proxy.extraParams = {
			movicentro: app.selectedMoviCentro.get ('id'),
			language: app.stores.bundle.language
		};
		Ext.apply (this.proxy.extraParams, appConfig.webservice.getArrivals.options);
		// Call super implementation.
		Ext.data.Store.prototype.load.call (this, options);
	}
});



app.stores.departures = new Ext.data.Store({
    model: "app.models.Journey",
	
	proxy: {
		type: appConfig.webservice.getDepartures.type || 'scripttag',
		url : appConfig.webservice.getDepartures.url,
		reader: {
			type: 'json'
		}
		// extraParams dynamically added on load()
	},
	
	
	
	// Override load() method.
	load: function (options)
	{
		this.proxy.extraParams = {
			movicentro: app.selectedMoviCentro.get ('id'),
			language: app.stores.bundle.language
		};
		Ext.apply (this.proxy.extraParams, appConfig.webservice.getDepartures.options);
		// Call super implementation.
		Ext.data.Store.prototype.load.call (this, options);
	}
});



app.stores.journeyStops = new Ext.data.Store({
    model: "app.models.JourneyStop",
	journey: null,
	
	proxy: {
		type: appConfig.webservice.getJourneyStops.type || 'scripttag',
		url : appConfig.webservice.getJourneyStops.url,
		reader: {
			type: 'json'
		}
		// extraParams dynamically added on load()
	},
	
	
	
	// Override load() method.
	load: function (options)
	{
		this.journey = options.journey;
		this.proxy.extraParams = {
			journey: options.journey.getId ()
		};
		Ext.apply (this.proxy.extraParams, appConfig.webservice.getJourneyStops.options);
		// Call super implementation.
		Ext.data.Store.prototype.load.call (this, options);
	}
});




app.stores.infos = new Ext.data.Store({
    model: "app.models.Info",
	
	proxy: {
		type: appConfig.webservice.getInfo.type || 'scripttag',
		url : appConfig.webservice.getInfo.url,
		reader: {
			type: 'json'
		}
		// extraParams dynamically added on load()
	},
	
	
	
	// Override load() method.
	load: function (options)
	{
		this.proxy.extraParams = {
			movicentro: app.selectedMoviCentro.get ('id'),
			language: app.stores.bundle.language
		};
		Ext.apply (this.proxy.extraParams, appConfig.webservice.getInfo.options);
		// Call super implementation.
		Ext.data.Store.prototype.load.call (this, options);
	}
});
