app.views.HomePage = Ext.extend(Ext.Panel, {
	fullscreen: true,
	ui: 'home',
	layout: {
		type: 'vbox',
		pack: 'center',
		align: 'stretch'
	},
	scroll: 'vertical',
	
	
	
	dockedItems: [
		{
			id: 'app-views-HomePage-headerToolbar',
			xtype: 'toolbar',
			dock: 'top',
			items : [
				{
					xtype : 'spacer'
				},
				
				{
					xtype : 'container',
					html : '<img src="resources/images/homeHeader_logo.png">',
					listeners:
					{
						el:
						{
							tap: function ()
							{
								app.views.viewport.showCredits ();
							}
						}
					}
				},
				
				{
					xtype : 'spacer'
				}
			]
		},
		{
			id: 'app-views-HomePage-messageLbl',
			dock: 'top',
			html: ''
		},

		
		
		
		{
			xtype: 'toolbar',
			dock: 'bottom',
			items : [
				{
					xtype : 'container',
					html : '<img src="resources/images/homeFooter_sx.png">',
					listeners:
					{
						el:
						{
							tap: function ()
							{
								app.views.viewport.showCredits ();
							}
						}
					}
				},
				{
					xtype : 'spacer'
				},
				
				{
					xtype : 'container',
					html : '<img src="resources/images/homeFooter_dx.png">',
					listeners:
					{
						el:
						{
							tap: function ()
							{
								app.views.viewport.showCredits ();
							}
						}
					}
				}
			]
		}
	],
	
	
	items: [
		{
			id: 'app-views-HomePage-departuresBtn',
			xtype: 'button',
			cls: 'actionBtn',
			handler: function (button, event)
			{
				app.views.viewport.showDepartures ();
			}
		},
		{
			id: 'app-views-HomePage-arrivalsBtn',
			xtype: 'button',
			cls: 'actionBtn',
			handler: function (button, event)
			{
				app.views.viewport.showArrivals ();
			}
		},
		{
			id: 'app-views-HomePage-infoBtn',
			xtype: 'button',
			cls: 'actionBtn',
			handler: function (button, event)
			{
				app.views.viewport.showInfos ();
			}
		},
		{
			id: 'app-views-HomePage-mapBtn',
			xtype: 'button',
			cls: 'actionBtn',
			handler: function (button, event)
			{
				app.views.viewport.showMapToMoviCentro ();
			}
		},
		{
			id: 'app-views-HomePage-moviCentroBtn',
			xtype: 'button',
			cls: 'actionBtn',
			handler: function (button, event)
			{
				app.views.viewport.showMoviCentro ();
			}
		}
	],

	
	
	initComponent: function ()
	{
		app.views.HomePage.superclass.initComponent.apply (this, arguments);
		
		Ext.getCmp ('app-views-HomePage-messageLbl').html = app.stores.bundle.format ('homePageMessage');
		
		Ext.getCmp ('app-views-HomePage-departuresBtn').html = app.stores.bundle.format ('departuresTitle');
		Ext.getCmp ('app-views-HomePage-arrivalsBtn').html = app.stores.bundle.format ('arrivalsTitle');
		Ext.getCmp ('app-views-HomePage-infoBtn').html = app.stores.bundle.format ('infoTitle');
		Ext.getCmp ('app-views-HomePage-moviCentroBtn').html = app.stores.bundle.format ('movicentroTitle');
		Ext.getCmp ('app-views-HomePage-mapBtn').html = app.stores.bundle.format ('mapTitle');
	}
});
