app.views.JourneyList = Ext.extend(Ext.Panel, {
	layout: 'fit',
	
	items: [{
		xtype: 'list',
		store: null,
		controller: null,
		onItemDisclosure: true,
		disableSelection: true,
		itemCls: '{[xindex % 2 === 0 ? "list-item-even" : "list-item-odd"]}',

		
		
		itemTpl:
		{
			html:
				'<span class="journey-time">{[ this.printTime (values.time) ]}</span>' +
				'<span class="journey-place">{placeName}</span>' +
				'<span class="journey-transportation-icon"><img src="{transportationTypeIcon}"/>',
			
		
		
			initialConfig:
			{
				printTime: function (t)
				{
					function pad (n) {return n < 10 ? '0' + n : n}
					
					return pad (t.getUTCHours ())
						+ ':'
						+ pad (t.getUTCMinutes ());
				}
			}
		},
		
		
		
		listeners:
		{
			itemtap: function (view, index, item, e)
			{
				Ext.dispatch({
					controller: view.controller,
					action: 'show',
					journey: view.store.getAt (index)
				});
			},



			// When data changes (updated or refreshed),
			// scroll the list to show the first entry.
			// This solves also the problem to show the 'emptyText'
			// when no data are available after an update.

			update: function (list)
			{
				list.scroller.scrollTo ({x:0, y:0}, null);
			},

			refresh: function (list)
			{
				list.scroller.scrollTo ({x:0, y:0}, null);
			}
		}
	}],
	
	

	/*
	listeners:
	{
		activate: function (comp)
		{
			NOTE: this seems to contribute to an issue on phisical devices (Samsung Galaxy S, Samsung Galaxy S2) where active tab remains blocked.

			// Force refresh of the list to sync 'emptyText' with past loaded data.
			// This problem happens only on first load.
			//this.items.getAt (0).refresh ();
		}
	},
	*/



	initComponent: function ()
	{
		app.views.JourneyList.superclass.initComponent.apply (this, arguments);
		
		var item = this.items.getAt (0);
		item.store = this.store;
		item.controller = this.controllerFn ();
		item.emptyText = app.stores.bundle.format (this.emptyTextBundleKey);
		
		this.title = app.stores.bundle.format (this.titleBundleKey);
	}
});



app.views.ArrivalsList = Ext.extend(app.views.JourneyList, {
	titleBundleKey: "arrivalsTitle",
	emptyTextBundleKey: "emptyArrivals",
	iconCls: "contract",
	store: app.stores.arrivals,
	controllerFn: function () {return app.controllers.arrivals;},
	ui: 'arrivals'
});



app.views.DeparturesList = Ext.extend(app.views.JourneyList, {
	titleBundleKey: "departuresTitle",
	emptyTextBundleKey: "emptyDepartures",
	iconCls: "expand",
	store: app.stores.departures,
	controllerFn: function () {return app.controllers.departures; },
	ui: 'departures'
});
