app.views.JourneyStopList = Ext.extend(Ext.Panel, {
	layout: 'fit',
	ui: 'journeyStop',
	//title: 'Stops',
	
	dockedItems: [
		new app.views.DefaultHeader (),
		{
			id: 'app-views-JourneyStopList-title',
			xtype: 'toolbar',
			title: '',
			dock: 'top',
			items : [
				{
					id: 'app.views.Viewport.backButton',
					xtype : 'button',
					ui: 'back',
					html: 'Back',
					//hidden: true,
					showAnimation: 'fade',
					
					handler: function ()
					{
						app.views.viewport.setActiveItem (
							app.views.mainView,
							{ type: 'slide', direction: 'right'}
						);
					}
				},
			]
		}
	],
	
	items: [{
		xtype: 'list',
		store: app.stores.journeyStops,
		disableSelection: true,
		itemCls: '{[xindex % 2 === 0 ? "list-item-even" : "list-item-odd"]}',

		
		
		itemTpl:
		{
			html:
				'<span class="journeyStop-time">{[ this.printTime (values.time) ]}</span>' +
				'<span class="journeyStop-place">{placeName}</span>',
			
		
		
			initialConfig:
			{
				printTime: function (t)
				{
					function pad (n) {return n < 10 ? '0' + n : n}
					
					return pad (t.getUTCHours ())
						+':'
						+ pad (t.getUTCMinutes ());
				}
			}
		},
			
			
		
		listeners:
		{
			// When data are updated, reset the list to show the first entry.
			update: function (list)
			{
				list.scroller.scrollTo ({x:0, y:0}, null);
				Ext.getCmp ('app-views-JourneyStopList-title').setTitle (
					app.stores.journeyStops.journey.get ('transportationType')
					+ ' &mdash; '
					+ app.stores.journeyStops.journey.get ('company')
				)
			}
		}
	}],



	initComponent: function ()
	{
		app.views.JourneyStopList.superclass.initComponent.apply (this, arguments);
		this.items.getAt (0).emptyText = app.stores.bundle.format ("emptyJourneyStops");
	}
});
