app.views.MainView = Ext.extend (Ext.TabPanel, {
	fullscreen: true,
	layout: 'card',
	tabBar: {
		dock: 'bottom',
		layout: {
			pack: 'center'
		}
	},
	// FIX: set 'cardSwitchAnimation' to 'null' to avoid bug on setActiveItem().
	// In some circumstances (e.g. on Samsung Galaxy S, Samsung Galaxy S2 devices
	// with Android 2.3.5) calling setActiveItem() to change active tab don't
	// works: the tabBar remains blocked on tab i-th when you try to switch to
	// tab j-th, with j < i; but changing to tab k-th, with k > i, works.
	// The bug seems related to some latency/sinchronization issue, disabling
	// the animation *seems* to solve the problem.
	cardSwitchAnimation: null,
//	{
//		type: 'slide',
//		cover: true
//	},
	defaults: {
		scrolls: 'vertical'
	},
	dockedItems: [
		new app.views.DefaultHeader (),
		{
			id: 'app-views-MainView-title',
			xtype: 'toolbar',
			title: '',
			dock: 'top'
		}
	],
	listeners:
	{
		cardswitch: function (comp)
		{
			comp.resetTitle ();
		},
		
		
		
		show: function (comp)
		{
			comp.resetTitle ();
		}
	},
	
	
	
	initComponent: function()
	{
		// Put instances of cards into app.views namespace
		Ext.apply (
			app.views,
			{
				arrivalsList: new app.views.ArrivalsList (),
				departuresList: new app.views.DeparturesList (),
				infoList: new app.views.InfoList (),
				moviCentroList: new app.views.MoviCentroList (),
				mapToMoviCentro: new app.views.MapToMoviCentro ()
			}
		);
		
		// Put instances of cards into viewport
		Ext.apply (
			this,
			{
				items: [
					app.views.departuresList,
					app.views.arrivalsList,
					app.views.infoList,
					app.views.mapToMoviCentro,
					app.views.moviCentroList
				]
			}
		);
		
		app.views.MainView.superclass.initComponent.apply (this, arguments);
	},
	
	
	
	resetTitle: function ()
	{
		Ext.getCmp ('app-views-MainView-title').setTitle (
			app.selectedMoviCentro.get ('name')
		);
	}
});
