app.views.MapToMoviCentro = Ext.extend(Ext.Panel, {
	iconCls: 'globe1',
	title: 'Map',

	layout: 'fit',
	
	items: [{
		id: 'app.views.MapToMoviCentro.map',
		xtype: 'map',
		
		mapOptions: {
			useCurrentLocation: true,
			mapTypeId: google.maps.MapTypeId.ROADMAP
		},
		
		directionsService: null,
		directionsRenderer: null,
		moviCentro: null
	}],



	listeners:
	{
		activate: function ()
		{
			if (app.devicePosition == null)
			{
				return;
			}
			
			var extMap = Ext.getCmp ('app.views.MapToMoviCentro.map');
			
			// Reset the map center to current device location.
			var gPos = app.views.MapToMoviCentro.positionModel2Google_ (app.devicePosition);
			extMap.map.setCenter (gPos);
			
			// Create needed "direction services".
			if (this.directionsService == null)
			{
				this.directionsService = new google.maps.DirectionsService ();
			}
			if (this.directionsRenderer != null)
			{
				// Fit map on already set direction.
				var d = this.directionsRenderer.getDirections ();
				var r = d.routes [this.directionsRenderer.getRouteIndex ()];
				extMap.map.fitBounds (r.bounds);
			}
			
			// Update if needed
			if (this.moviCentro != app.selectedMoviCentro && app.selectedMoviCentro != null)
			{
				// Remove any previous route.
				if (this.directionsRenderer != null)
				{
					this.directionsRenderer.setMap (null);
					this.directionsRenderer = null;
					extMap.map.setCenter (gPos);
				}
				
				this.moviCentro = app.selectedMoviCentro;
				
				var this_ = this;
				this.directionsService.route (
					{
						origin: gPos,
						destination: app.views.MapToMoviCentro.positionModel2Google_ (this.moviCentro.getPosition ()),
						travelMode: google.maps.TravelMode.WALKING
					},

					function (result, status)
					{
						if (status == google.maps.DirectionsStatus.OK)
						{
							this_.directionsRenderer = new google.maps.DirectionsRenderer ({
								map: extMap.map,
								directions: result
							});
						}
					}
				);
			}
		}
	},
	
	
	
	initComponent: function ()
	{
		app.views.MapToMoviCentro.superclass.initComponent.apply (this, arguments);
		
		this.title = app.stores.bundle.format ('mapTitle');
	}
});



app.views.MapToMoviCentro.positionModel2Google_ = function (p)
{
	return new google.maps.LatLng (
		p.get ('latitude'),
		p.get ('longitude')
	);
}
