app.views.Viewport = Ext.extend (Ext.Panel, {
	fullscreen: true,
	layout: 'card',
	cardSwitchAnimation: {
		type: 'slide',
		cover: true
	},
	defaults: {
		scrolls: 'vertical'
	},



	initComponent: function()
	{
		// Put instances of cards into app.views namespace
		// NOTE: credits pop-up must be created later to get the right dimensions.
		Ext.apply (
			app.views,
			{
				homePage: new app.views.HomePage (),
				mainView: new app.views.MainView (),
				journeyStopsList: new app.views.JourneyStopList ()
			}
		);
		
		// Put instances of cards into viewport
		Ext.apply (
			this,
			{
				items: [
					app.views.homePage,
					app.views.mainView,
					app.views.journeyStopsList
				]
			}
		);
		
		app.views.Viewport.superclass.initComponent.apply (this, arguments);
		
//		Ext.getCmp ('app.views.Viewport.backButton').html = app.stores.bundle.format ('backButton');
	},
	
	
	
	setActiveItem: function (newCard, animation)
	{
		app.views.Viewport.superclass.setActiveItem.apply (this, arguments);
//		Ext.getCmp ('app.views.Viewport.backButton').setVisible (newCard != app.views.mainView);
	},
	
	
	
	showDepartures: function (animation)
	{
		app.views.mainView.setActiveItem (app.views.departuresList);
		app.views.viewport.setActiveItem (app.views.mainView, animation);
	},
	
	
	
	showArrivals: function (animation)
	{
		app.views.mainView.setActiveItem (app.views.arrivalsList);
		app.views.viewport.setActiveItem (app.views.mainView, animation);
	},
	
	
	
	showInfos: function (animation)
	{
		app.views.mainView.setActiveItem (app.views.infoList);
		app.views.viewport.setActiveItem (app.views.mainView, animation);
	},
	
	
	
	showMoviCentro: function (animation)
	{
		app.views.mainView.setActiveItem (app.views.moviCentroList);
		app.views.viewport.setActiveItem (app.views.mainView, animation);
	},
	
	
	
	showMapToMoviCentro: function (animation)
	{
		app.views.mainView.setActiveItem (app.views.mapToMoviCentro);
		app.views.viewport.setActiveItem (app.views.mainView, animation);
	},
	
	
	
	showCredits: function (animation)
	{
		if (! app.views.credits)
		{
			app.views.credits = new app.views.Credits ();
		}
		app.views.credits.show ('pop');
	},
	
	
	
	showHomePage: function (animation)
	{
		this.setActiveItem (app.views.homePage, animation);
	}
});
